#!/usr/bin/python

# ./svg_levels.py >svg_levels.lua

import os, glob
from lxml import etree
from lxml.cssselect import CSSSelector

print '-- autogenerated by svg_levels.py\n\nsvg_objects = {'

ns = {'svg': 'http://www.w3.org/2000/svg',
      'ink': 'http://www.inkscape.org/namespaces/inkscape'}

other = ''

for svg in glob.glob('data/*.svg'):
    t = etree.parse(svg)
    basefile = os.path.basename(svg).split('.')[0]
    print '%s = {' % basefile

    sel = CSSSelector('svg|rect[ink|label="displace"]', ns)
    for e in sel(t):
        x, y = float(e.get('x')), float(e.get('y'))
        w, h = float(e.get('width')), float(e.get('height'))

        print """
Displacer:new{
  x = %f, y = %f,
  width = %f, height = %f
},
""" % (x,y,w,h)

    sel = CSSSelector('svg|rect[ink|label="maybedisplace"]', ns)
    for e in sel(t):
        x, y = float(e.get('x')), float(e.get('y'))
        w, h = float(e.get('width')), float(e.get('height'))

        print """
MaybeDisplacer:new{
  x = %f, y = %f,
  width = %f, height = %f
},
""" % (x,y,w,h)

    sel = CSSSelector('svg|rect[ink|label="transition"]', ns)
    for e in sel(t):
        x, y = float(e.get('x')), float(e.get('y'))
        w, h = float(e.get('width')), float(e.get('height'))

        desc = ""
        descSel = CSSSelector('svg|desc', ns)
        for d in descSel(e):
            desc = desc + d.text

        print """
Transition:new{
  x = %f, y = %f,
  width = %f, height = %f,
  %s
},
""" % (x,y,w,h, desc)

    sel = CSSSelector('svg|rect[ink|label="flower"]', ns)
    for e in sel(t):
        x, y = float(e.get('x')), float(e.get('y'))

        print """
Flower:new{
  x = %f, y = %f,
},
""" % (x,y)

    sel = CSSSelector('svg|rect[ink|label="cat"]', ns)
    for e in sel(t):
        x, y = float(e.get('x')), float(e.get('y'))

        print """
Cat:new{
  x = %f, y = %f,
},
""" % (x,y)

    sel = CSSSelector('svg|rect[ink|label="fish"]', ns)
    for e in sel(t):
        x, y = float(e.get('x')), float(e.get('y'))
        w, h = float(e.get('width')), float(e.get('height'))

        print """
Fish:new{
  x = %f, y = %f,
  width = %f, height = %f,
},
""" % (x,y,w,h)

    sel = CSSSelector('svg|rect[ink|label="flag"]', ns)
    for e in sel(t):
        x, y = float(e.get('x')), float(e.get('y'))
        w, h = float(e.get('width')), float(e.get('height'))

        print """
Flag:new{
  x = %f, y = %f,
  width = %f, height = %f,
},
""" % (x,y,w,h)

    sel = CSSSelector('svg|rect[ink|label="fairy"]', ns)
    for e in sel(t):
        x, y = float(e.get('x')), float(e.get('y'))
        w, h = float(e.get('width')), float(e.get('height'))

        print """
Fairy:new{
  x = %f, y = %f,
  width = %f, height = %f,
},
""" % (x,y,w,h)

    sel = CSSSelector('svg|rect[ink|label="gatetrigger"]', ns)
    for e in sel(t):
        x, y = float(e.get('x')), float(e.get('y'))
        w, h = float(e.get('width')), float(e.get('height'))

        print """
GateTrigger:new{
  x = %f, y = %f,
  width = %f, height = %f,
},
""" % (x,y,w,h)

    sel = CSSSelector('svg|rect[ink|label="fairyactivator"]', ns)
    for e in sel(t):
        x, y = float(e.get('x')), float(e.get('y'))
        w, h = float(e.get('width')), float(e.get('height'))

        print """
FairyActivator:new{
  x = %f, y = %f,
  width = %f, height = %f,
},
""" % (x,y,w,h)

    sel = CSSSelector('svg|rect[ink|label="boat"]', ns)
    for e in sel(t):
        x, y = float(e.get('x')), float(e.get('y'))
        #w, h = float(e.get('width')), float(e.get('height'))

        print """
Boat:new{
  x = %f, y = %f,
},
""" % (x,y)

    sel = CSSSelector('svg|rect[ink|label="troll"]', ns)
    for e in sel(t):
        x, y = float(e.get('x')), float(e.get('y'))
        #w, h = float(e.get('width')), float(e.get('height'))

        print """
Troll:new{
  x = %f, y = %f,
},
""" % (x,y)


    print '},'

    # gate...
    sel = CSSSelector('svg|rect[ink|label="gateup"]', ns)
    for e in sel(t):
        x, y = float(e.get('x')), float(e.get('y'))
        w, h = float(e.get('width')), float(e.get('height'))

        other = other + """
gateup = Fill:new{
  x = %f, y = %f,
  width = %f, height = %f,
  fill = {108,57,22,255},
  gateup = true
}
""" % (x,y,w,h)

    sel = CSSSelector('svg|rect[ink|label="gatedown"]', ns)
    for e in sel(t):
        x, y = float(e.get('x')), float(e.get('y'))
        w, h = float(e.get('width')), float(e.get('height'))

        other = other + """
gatedown = Fill:new{
  x = %f, y = %f,
  width = %f, height = %f,
  fill = {108,57,22,255},
  visible = false
}
""" % (x,y,w,h)

    sel = CSSSelector('svg|rect[ink|label="fairytarget"]', ns)
    for e in sel(t):
        x, y = float(e.get('x')), float(e.get('y'))
        w, h = float(e.get('width')), float(e.get('height'))

        other = other + """
fairytarget = Sprite:new{
  x = %f, y = %f,
  width = %f, height = %f,
  visible = false
}
""" % (x,y,w,h)


print '}'

print other
